
#include "x.h"
#include "xt.h"
#include "resources.h"
#include <stdio.h>
#include <string.h>

XtAppContext app_context;
Widget toplevel;

void
main( argc, argv )
int argc;
char *argv[];
{
    char *trans_file = NULL;
    char *directory = NULL;
    extern char *getenv ();
    char * buffer;

    Widget top_pane, box, createAnim;
    extern void finalQuit();
    extern void makeTrans();

    static XtResource resources[] = { NULL };

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    if( strlen( getenv( "OBJ_PATH" ) ) == 0 ) {
        fprintf( stderr, "Environment variable OBJ_PATH, undefined\n\n" );
        exit( -1 );
    }

    toplevel = XtAppInitialize( &app_context, "CreateAnimation",
                             NULL, ZERO,
                             &argc, argv,
                             fallback_resources,
                             NULL, ZERO );

    XtGetApplicationResources( toplevel, (XtPointer) NULL,
                               resources, XtNumber( resources ),
                               NULL, ZERO );

    top_pane = XtVaCreateManagedWidget( "top_pane",
                                        panedWidgetClass, toplevel, NULL );

    XtVaCreateManagedWidget( "Create Animation", labelWidgetClass, top_pane,
                             XtNborderWidth, 0, NULL);

    box = XtVaCreateManagedWidget( "box", boxWidgetClass, top_pane,
                                   XtNorientation, XtorientHorizontal, NULL );

    callbacks[0].callback = (XtCallbackProc) finalQuit;
    callbacks[0].closure  = (XtPointer) NULL;
    XtVaCreateManagedWidget( "quit", commandWidgetClass, box,
                             XtNcallback, callbacks, NULL);

    callbacks[0].callback = (XtCallbackProc) makeTrans;
    callbacks[0].closure  = (XtPointer) argv[1];
    createAnim = XtVaCreateManagedWidget( "createAnim",
		commandWidgetClass, box, NULL );
    XtAddCallback( createAnim, XtNcallback, makeTrans, (XtPointer)argv[1] );

    XtRealizeWidget( toplevel );
    XtAppMainLoop( app_context );
}


void
finalQuit( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
   XtDestroyApplicationContext(app_context);
   (void) exit (0);
}
