
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readMountainValues();
int checkMountainValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *text1, *text2, *text3, *text4, *text5;
} 
Text, *TextPtr;


typedef struct _Pass {
    TextPtr text;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateMountains( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label2, g_label3, g_label4, g_label5;
    Widget    g_text1, g_text2, g_text3, g_text4, g_text5;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Mountain.seed = time(0);
    ObjectValues.Obj.Mountain.maxlevel = 5;
    ObjectValues.Obj.Mountain.H = 1.0;
    ObjectValues.Obj.Mountain.sigma = 0.8;
    ObjectValues.Obj.Mountain.addition = 1;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Mountain" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "mountain_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_title1,
        XtNlabel, "seed",
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Mountain.seed );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_label1,
        NULL );

    g_label2 = XtVaCreateManagedWidget( "g_label2", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label1,
        XtNlabel, "maxlevel",
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Mountain.maxlevel );
    text->text2 = XtNewString( buffer );
    g_text2  = XtVaCreateManagedWidget( "g_text2", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text2,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text2),
        XtNfromVert, g_label1,
        XtNfromHoriz, g_label2,
        NULL );

    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label2,
        XtNlabel, "H",
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%lf", ObjectValues.Obj.Mountain.H );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text3,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text3),
        XtNfromVert, g_label2,
        XtNfromHoriz, g_label3,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label3,
        XtNlabel, "sigma",
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%lf", ObjectValues.Obj.Mountain.sigma );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_label3,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label4,
        XtNlabel, "addition",
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Mountain.addition );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    pass->text = text;

    callbacks[0].callback = (XtCallbackProc) readMountainValues;
    callbacks[0].closure  = (XtPointer) text;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label5,
        XtNvertDistance, 20,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label5,
        XtNfromHoriz, g_ok,
        XtNvertDistance, 20,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readMountainValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    TextPtr ptext = (TextPtr) client_data;
    extern char creatingObject;

    int maxlevel, seed, addition;
    double H, sigma;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->text1, "%d", &seed );
    XtFree( ptext->text1 );
    sscanf( ptext->text2, "%d", &maxlevel );
    XtFree( ptext->text2 );
    sscanf( ptext->text3, "%lf", &H );
    XtFree( ptext->text3 );
    sscanf( ptext->text4, "%lf", &sigma );
    XtFree( ptext->text4 );
    sscanf( ptext->text5, "%d", &addition );
    XtFree( ptext->text5 );

    ObjectValues.Obj.Mountain.seed = seed;
    ObjectValues.Obj.Mountain.maxlevel = maxlevel;
    ObjectValues.Obj.Mountain.H = H;
    ObjectValues.Obj.Mountain.sigma = sigma;
    ObjectValues.Obj.Mountain.addition = addition;

    if( !(status = checkMountainValues( popup, maxlevel, seed, addition, H, sigma ) ) )
        MidPointFM2D( maxlevel, seed, addition, H, sigma );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkMountainValues( w, maxlevel, seed, addition, H, sigma )
Widget w;
int maxlevel, seed, addition;
double H, sigma;
{
    int errors = 0;

    return errors;
}

