
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readSphereValues();
int checkSphereValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text1, *text3;
} Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} 
Widg, *WidgPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
} 
Pass, *PassPtr;



/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateSphere( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    WidgPtr   widg = (WidgPtr) malloc( sizeof (Widg) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label3, g_label7;
    Widget    g_text1, g_text3, g_toggle7;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_labelC, g_textC;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Sphere.radius = 1.0;
    ObjectValues.Obj.Sphere.center.x = 0.0;
    ObjectValues.Obj.Sphere.center.y = 0.0;
    ObjectValues.Obj.Sphere.center.z = 0.0;
    ObjectValues.Obj.Sphere.depth = 3;
    ObjectValues.Obj.Sphere.clockwise = False;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
		XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Sphere" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "sphere_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*strlen(text->filetext),
        XtNinsertPosition, strlen(text->filetext),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,
        g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_title1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Sphere.center.x,
           ObjectValues.Obj.Sphere.center.y, ObjectValues.Obj.Sphere.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_labelC,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Sphere.radius );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text3,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text3),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label3,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label3,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Sphere.depth );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 1,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_label3,
        XtNfromHoriz, g_label1,
        NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
        XtNfromVert, g_label1,
        NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
        XtNfromVert, g_label001,
        NULL );
    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
        XtNfromVert, g_title2,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_title2,
        XtNfromHoriz, g_label7,
        NULL );
    if( ObjectValues.Obj.Sphere.clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
        XtNfromVert, g_label7,
        NULL );

    widg->cl = g_toggle7;
    pass->text = text;
    pass->widg = widg;

    callbacks[0].callback = (XtCallbackProc) readSphereValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        XtNfromHoriz, g_ok,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readSphereValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    PassPtr pass = (PassPtr) client_data;
    WidgPtr pwidg = (WidgPtr) pass->widg;
    TextPtr ptext = (TextPtr) pass->text;
    extern char creatingObject;

    float radius;
    int depth;
    Point center;
    Boolean clockwise;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textC, "%f %f %f", &(center.x), &(center.y), &(center.z) );
    XtFree( ptext->textC );
    sscanf( ptext->text1, "%d", &depth );
    XtFree( ptext->text1 );
    sscanf( ptext->text3, "%f", &radius );
    XtFree( ptext->text3 );
    XtVaGetValues( pwidg->cl, XtNstate, &clockwise, NULL );

    ObjectValues.Obj.Sphere.radius = radius;
    ObjectValues.Obj.Sphere.center.x = center.x;
    ObjectValues.Obj.Sphere.center.y = center.y;
    ObjectValues.Obj.Sphere.center.z = center.z;
    ObjectValues.Obj.Sphere.depth = depth;
    ObjectValues.Obj.Sphere.clockwise = clockwise;

    if( !(status = checkSphereValues( popup, radius, depth ) ) )
        Sphere( radius, center, depth, clockwise, primitive );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkSphereValues( w, radius, depth )
Widget w;
float radius;
int depth;
{
    char buffer[80];
    int errors = 0;

    if( depth < 1 || depth > 7 ) {
        sprintf( buffer, "Error -- Required Condition: 1 <= depth(%d) <= 7\n",
            depth );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( radius ) ) {
        sprintf( buffer, "Error -- Required Condition: radius(%.2f) > 0.0\n",
            radius );
        message( w, buffer );
        errors++;
    }
    return errors;
}
